︠d596bbec-b33d-4bbd-b85f-bc9afc1ca5f6i︠
%hide
html('<script type="text/javascript">var code = "empty"; function processTask(){evaluate_cell(22); code = "%hide\\n" + "myxml = \'\'\\n" + "myxml = " + " \'\'\'" + document.applets[0].getXML() + " \'\'\' "; \$("#cell_input_30").val(code); evaluate_cell(30); \$("#cell_input_29").val(code); evaluate_cell(29); \$("#cell_input_28").val(code); evaluate_cell(28); \$("#cell_input_17").val(code); evaluate_cell(17); evaluate_cell(8);}</script>') 
html('<script type="text/javascript">function resetApplet(){document.applets[0].reset();}</script>')
︡a481a954-e0b1-4847-a408-77f585fab738︡{"html": "<font color='black'><script type=\"text/javascript\">var code = \"empty\"; function processTask(){evaluate_cell(22); code = \"%hide\\n\" + \"myxml = ''\\n\" + \"myxml = \" + \" '''\" + document.applets[0].getXML() + \" ''' \"; $(\"#cell_input_30\").val(code); evaluate_cell(30); $(\"#cell_input_29\").val(code); evaluate_cell(29); $(\"#cell_input_28\").val(code); evaluate_cell(28); $(\"#cell_input_17\").val(code); evaluate_cell(17); evaluate_cell(8);}</script></font>"}︡{"html": "<font color='black'><script type=\"text/javascript\">function resetApplet(){document.applets[0].reset();}</script></font>"}︡
︠fecaf5f2-b94c-470d-a7fa-bc3d40a6dd97i︠
%html
<h1 style="text-align: center;"><span><span style="background-color: #333399;"><span style="color: #ffffff;">- Automatic determination of GeoGebra loci -</span></span></span></h1>

<h3 style="text-align: center;"><span><span style="background-color: #333399;"><span style="color: #ffffff;"></span></span></span></h3>

<p><b>Create or upload</b> a locus construction in the following GeoGebra applet. Sage will be used to (symbolically) determine an exact geometric description of the locus.</p>

<p>The <strong>allowed GeoGebra elements</strong> (currently) are: free points, Midpoint(point-point), Point(on Circle and on Line), Line(point-point, point-line -meaning a parallel), OrthogonalLine, Circle(center-radius, center-point, center-radius_as_segment), Intersect(object-object), Locus and Relation between Two Objects (parallelism, perpendicularity).</p>
<center>
<applet id ="ggbAp" name="ggbAp"  code="geogebra.GeoGebraApplet" archive="http://www.geogebra.org/webstart/4.0/geogebra.jar" width=900 height=500 MAYSCRIPT>
  <param name="framePossible" value="false"/>
  <param name="showToolBar" value="true"/><param name="showAlgebraInput" value="true"/>
  <param name="filename" value="http://www.sagenb.org/home/mabanades/23/data/limacon_sin_segmento4.ggb"/>
  <param name="language" value="en"/><param name="showMenuBar" value="true"/>
</applet>
<form> <input onclick="resetApplet();" type="button" value="Reset Applet" /> </form>
<h2>Just press the Submit task button</h2>
<form> <input onclick="processTask();" type="button" value="Submit task" /> </form>
</center>
<h2>ANSWER:</h2>
*************************************************************************************

︡95429aad-364e-41dd-bd54-ed2786368105︡{"html": "<h1 style=\"text-align: center;\"><span><span style=\"background-color: #333399;\"><span style=\"color: #ffffff;\">- Automatic determination of GeoGebra loci -</span></span></span></h1>\r\n\r\n<h3 style=\"text-align: center;\"><span><span style=\"background-color: #333399;\"><span style=\"color: #ffffff;\"></span></span></span></h3>\r\n\r\n<p><b>Create or upload</b> a locus construction in the following GeoGebra applet. Sage will be used to (symbolically) determine an exact geometric description of the locus.</p>\r\n\r\n<p>The <strong>allowed GeoGebra elements</strong> (currently) are: free points, Midpoint(point-point), Point(on Circle and on Line), Line(point-point, point-line -meaning a parallel), OrthogonalLine, Circle(center-radius, center-point, center-radius_as_segment), Intersect(object-object), Locus and Relation between Two Objects (parallelism, perpendicularity).</p>\r\n<center>\r\n<applet id =\"ggbAp\" name=\"ggbAp\"  code=\"geogebra.GeoGebraApplet\" archive=\"http://www.geogebra.org/webstart/4.0/geogebra.jar\" width=900 height=500 MAYSCRIPT>\r\n  <param name=\"framePossible\" value=\"false\"/>\r\n  <param name=\"showToolBar\" value=\"true\"/><param name=\"showAlgebraInput\" value=\"true\"/>\r\n  <param name=\"filename\" value=\"http://www.sagenb.org/home/mabanades/23/data/limacon_sin_segmento4.ggb\"/>\r\n  <param name=\"language\" value=\"en\"/><param name=\"showMenuBar\" value=\"true\"/>\r\n</applet>\r\n<form> <input onclick=\"resetApplet();\" type=\"button\" value=\"Reset Applet\" /> </form>\r\n<h2>Just press the Submit task button</h2>\r\n<form> <input onclick=\"processTask();\" type=\"button\" value=\"Submit task\" /> </form>\r\n</center>\r\n<h2>ANSWER:</h2>\r\n*************************************************************************************"}︡
︠78b1432d-93a1-4bf2-87df-35c86f1f43e9i︠
%hide

########################################

#load(DATA+'AutDedLocusDeg.sage')
init1()

#########################################

from xml.etree import ElementTree as ET

myxml_modified = ""

myxml_modified = (myxml.replace('\n','')).replace('\t','')

ggb = ET.XML(myxml_modified)

"""Since the construction XML element lies on different parts in GeoGebra 3.2 and GeoGebra 4.0, we read it as appropriate and set its value in cons"""
if ggb.items()[1][1]=='3.2':
    cons=ggb[3]
else:
    cons=ggb[4]


################
nombreLocus = ""
################
    
#next we process the GeoGebra locus construction     
     
def eval_cons(cons):
    for i in cons:
        b=i.items()
        if i.tag=='element' and b[0][1]=='point' and not (b[1][1] in Todo.keys()):
            dic=dict(i.find('coords').items())
            coord_x=sage_eval(dic['x']);coord_y=sage_eval(dic['y'])
            coord_x=coord_x.simplest_rational();coord_y=coord_y.simplest_rational()
            FreePoint(str(b[1][1]),coord_x,coord_y)
        elif i.tag=='command':
             if b[0][1]=='Circle':
                 dic_in=dict(i.find('input').items())
                 dic_out=dict(i.find('output').items())
                 """Circle cases: center-radius, center-point,center-radius_as_segment"""
                 if dic_in['a1'].find('Segment[') <> -1:
                     seg=dic_in['a1']
                     p=seg.split(',')[0];p=p.replace('Segment[','')
                     q=seg.split(',')[1];q=q.replace(']','');q=q.replace(' ','')       
                     Circle(dic_out['a0'],dic_in['a0'],p,q)
                 elif dic_in['a1'][0].isalpha():
                     Circle(dic_out['a0'],dic_in['a0'],dic_in['a1'])
                 else:
                     rad=sage_eval(dic_in['a1']);rad=rad.simplest_rational()
                     Circle(dic_out['a0'],dic_in['a0'],rad)
             elif b[0][1]=='Segment':
                 """The second ggb Segment definition is not implemented here"""
                 dic_in=dict(i.find('input').items())
                 dic_out=dict(i.find('output').items())
                 Segment(dic_out['a0'],dic_in['a0'],dic_in['a1'])
             elif b[0][1]=='Line':
                 """2 cases: line(point,point) and line(point,line), meaning a parallel ..."""
                 dic_in=dict(i.find('input').items())
                 dic_out=dict(i.find('output').items())
                 if is_point(dic_in['a1']):
                     Line(dic_out['a0'],dic_in['a0'],dic_in['a1'])
                 else:
                     ParallelLine(dic_out['a0'],dic_in['a0'],dic_in['a1'])
             elif b[0][1]=='Midpoint':
                 """midpoint of two given points"""
                 dic_in=dict(i.find('input').items())
                 dic_out=dict(i.find('output').items())
                 MidPoint(dic_out['a0'],dic_in['a0'],dic_in['a1'])
             elif b[0][1]=='OrthogonalLine':
                 """perpendicular line through a given point to a given line"""
                 dic_in=dict(i.find('input').items())
                 dic_out=dict(i.find('output').items())
                 PerpendicularLine(dic_out['a0'],dic_in['a0'],dic_in['a1'])
             elif b[0][1]=='Point':
                 """Point on Circle"""
                 dic_in=dict(i.find('input').items())
                 dic_out=dict(i.find('output').items())
                 PointOnObject(dic_out['a0'],dic_in['a0'])
             elif b[0][1]=='Intersect':
                 """computes the intersection of any pair of linear objects"""
                 dic_in=dict(i.find('input').items())
                 dic_out=dict(i.find('output').items())
                 IntersectionObjectObject(dic_out['a0'],dic_in['a0'],dic_in['a1'])
             elif b[0][1]=='Locus':
                 """computes an explicit locus"""
                 dic_in=dict(i.find('input').items())
                 dic_out=dict(i.find('output').items())
                 Locus(dic_out['a0'],dic_in['a0'],dic_in['a1'])
                 #############################
                 global nombreLocus
                 nombreLocus = dic_out['a0']
                 #############################
    
eval_cons(cons)



##############################################################

componentList = Todo[nombreLocus]['constructible']


########################
#print str(componentList)
########################


numberComponents = len(componentList)

sustraendosList = []

for component in componentList: 
    sustraendosList.append(component[0][1])
  
nontriviualSustraendosList = []
for sus in sustraendosList:
    if str(sus) != "[[1]]":
        nontriviualSustraendosList.append(sus)

finalUnionElementList = []
for component in componentList: 
    if len(component[0][0]) > 1:
        intersectionElement = ""
        for index in range(len(component[0][0])-1):
            intersectionElement = intersectionElement + '('+ str(component[0][0][index]) + ' = 0) INTERSECTION ' 
        intersectionElement = intersectionElement + '('+ str(component[0][0][-1]) + ' = 0)'
        finalUnionElementList.append(intersectionElement)
    else:
        finalUnionElementList.append(str(component[0][0][0]) + ' = 0')

##########################    
#print str(finalUnionElementList)
##########################
 
locusTextDescription = ""
for index in range(len(finalUnionElementList)-1):
    locusTextDescription = locusTextDescription + '['+ str(finalUnionElementList[index]) + '] UNION '
locusTextDescription = locusTextDescription + '['+ str(finalUnionElementList[-1]) + ']'

locusTextDescription = locusTextDescription.replace('L','')

finalEquationFactorList = []
for component in componentList: 
    if len(component[0][0]) > 1:
        factor = ""
        for index in range(len(component[0][0])-1):
            factor = factor + '(' + str(component[0][0][index]) + ')^2+'
        factor = factor + '(' + str(component[0][0][-1]) + ')^2'
        finalEquationFactorList.append(factor)
    else:
        finalEquationFactorList.append(str(component[0][0][0]))

###################################
#print str(finalEquationFactorList)
###################################

equation4ggb = ""

for index in range(len(finalEquationFactorList)-1):
    equation4ggb = equation4ggb + '('+ str(finalEquationFactorList[index]) + ')*'
equation4ggb = equation4ggb + '('+ str(finalEquationFactorList[-1]) + ') = 0'

equation4ggb = equation4ggb.replace('L','')

##################
#print equation4ggb
##################

extraStuffEcuaciones = []
for nontrivialSustraendo in nontriviualSustraendosList:
    for parte in nontrivialSustraendo:
        ecuacionBuena = "["
        for index in range(len(parte)-1):
            ecuacionBuena = ecuacionBuena + '(' + str(parte[index]) + ' = 0) AND '
        ecuacionBuena = ecuacionBuena + '(' + str(parte[-1]) + ' = 0)]'
        extraStuffEcuaciones.append(ecuacionBuena)
 
equationExtraStuff = ""

if len(extraStuffEcuaciones) != 0:

    for index in range(len(extraStuffEcuaciones)-1):
        equationExtraStuff = equationExtraStuff + str(extraStuffEcuaciones[index]) + ' OR '
    equationExtraStuff = equationExtraStuff + str(extraStuffEcuaciones[-1])

equationExtraStuff = equationExtraStuff.replace('L','')
 
if len(nontriviualSustraendosList) == 0:
             
    html('<script type="text/javascript">document.applets[0].evalCommand("%s")</script>'%(equation4ggb))
    html('<script type="text/javascript">var numberOfElements = document.applets[0].getObjectNumber(); var nameLastElement =    document.applets[0].getObjectName(numberOfElements-1); document.applets[0].setColor(nameLastElement, 0, 0, 250); document.applets[0].setLineThickness(nameLastElement, 5); document.applets[0].setLineStyle(nameLastElement, 3);</script>')
    print "The algebraic description of the locus is \n\n" + locusTextDescription + "\n\nIts graph has been added to the construction in the applet (dotted blue)."
    
else:
    html('<script type="text/javascript">document.applets[0].evalCommand("%s")</script>'%(equation4ggb))
    html('<script type="text/javascript">var numberOfElements = document.applets[0].getObjectNumber(); var nameLastElement =    document.applets[0].getObjectName(numberOfElements-1); document.applets[0].setColor(nameLastElement, 0, 0, 250); document.applets[0].setLineThickness(nameLastElement, 5); document.applets[0].setLineStyle(nameLastElement, 3);</script>')
    print "The locus is composed of the set with the following algebraic description \n\n    " + locusTextDescription + "\n\n(whose graph - dotted blue - has been added to the construction in the applet above)" + "\n\nfrom which we have to REMOVE the set determined by the following conditions: \n\n    " + equationExtraStuff
︡8ecb9100-a043-4aa2-8c71-17a9ca5fc164︡{"stdout": "The component  x3^2 + x4^2 - 6*x3 - 8*x4 + 24  is degenerated for  [x2 - 4, x1 - 3] !\nThe component  x3^2 + x4^2 - 6*x3 - 8*x4 + 24  is degenerated for  [x2 - 4, x1 - 3] !"}︡{"html": "<font color='black'><script type=\"text/javascript\">document.applets[0].evalCommand(\"(625*x^4 + 1250*x^2*y^2 - 11000*x^3 + 72125*x^2 + 625*y^4 - 5650*x^2*y - 11000*x*y^2 - 5650*y^3 + 49720*x*y + 36494*y^2 - 210530*x - 105062*y + 221544) = 0\")</script></font>"}︡{"html": "<font color='black'><script type=\"text/javascript\">var numberOfElements = document.applets[0].getObjectNumber(); var nameLastElement =    document.applets[0].getObjectName(numberOfElements-1); document.applets[0].setColor(nameLastElement, 0, 0, 250); document.applets[0].setLineThickness(nameLastElement, 5); document.applets[0].setLineStyle(nameLastElement, 3);</script></font>"}︡{"stdout": "The algebraic description of the locus is \n\n[625*x^4 + 1250*x^2*y^2 - 11000*x^3 + 72125*x^2 + 625*y^4 - 5650*x^2*y - 11000*x*y^2 - 5650*y^3 + 49720*x*y + 36494*y^2 - 210530*x - 105062*y + 221544 = 0]\n\nIts graph has been added to the construction in the applet (dotted blue)."}︡
︠c3eae5dd-1951-4fbe-8276-3b6dd7065a69i︠
%html
*************************************************************************************
<h4><b>Restart</b> the worksheet (<i>Action</i> menu above) before computing a new locus.</h4>

︡e776f3f2-926a-47de-93e3-b724cac7e22e︡{"html": "*************************************************************************************\r\n<h4><b>Restart</b> the worksheet (<i>Action</i> menu above) before computing a new locus.</h4>"}︡
︠972f2005-35f4-42a8-9500-a18412e5d610i︠
%hide
myxml = ''
myxml =  '''<?xml version="1.0" encoding="utf-8"?>
<geogebra format="4.0" id="8e6a4458-d48b-404b-8720-6b90f787493c"  xsi:noNamespaceSchemaLocation="http://www.geogebra.org/ggb.xsd" xmlns="" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >
<gui>
	<window width="800" height="600" />
	<perspectives>
<perspective id="tmp">
	<panes>
		<pane location="" divider="0.4073319755600815" orientation="1" />
	</panes>
	<views>
		<view id="4" toolbar="0 || 2020 , 2021 , 2022 , 66 || 2001 , 2003 , 2002 , 2004 , 2005 || 2040 , 2041 , 2042 , 2044 , 2043" visible="false" inframe="false" stylebar="false" location="1,1" size="200" window="0,0,400,400" />
		<view id="1" visible="true" inframe="false" stylebar="false" location="1" size="575" window="0,0,400,400" />
		<view id="2" visible="true" inframe="false" stylebar="false" location="3" size="400" window="0,0,200,400" />
		<view id="16" visible="false" inframe="true" stylebar="false" location="1" size="150" window="50,50,500,500" />
		<view id="32" visible="false" inframe="true" stylebar="true" location="1" size="150" window="50,50,500,500" />
		<view id="64" visible="false" inframe="true" stylebar="false" location="1" size="150" window="50,50,500,500" />
	</views>
	<toolbar show="true" items="0 39 59 || 1 501 67 , 5 19 , 72 | 2 15 45 , 18 65 , 7 37 | 4 3 8 9 , 13 44 , 58 , 47 || 16 51 64 , 70 | 10 34 53 11 , 24  20 22 , 21 23 | 55 56 57 , 12 || 36 46 , 38 49 50 , 71 | 30 29 54 32 31 33 | 17 26 62 , 14 66 68 | 25 52 60 61 || 40 41 42 , 27 28 35 , 6" />
	<input show="true" cmd="true" top="false" />
</perspective>
	</perspectives>
	<labelingStyle  val="3"/>
	<font  size="12"/>
	<graphicsSettings javaLatexFonts="false"/>
	<consProtColumns  col0="true" col1="true" col2="false" col3="true" col4="false" col5="true" col6="true" col7="false"/>
	<consProtocol useColors="true" addIcons="false" showOnlyBreakpoints="false"/>
</gui>
<euclidianView>
	<size  width="575" height="442"/>
	<coordSystem xZero="133.99999999999991" yZero="296.0" scale="49.99999999999998" yscale="50.0"/>
	<evSettings axes="true" grid="true" gridIsBold="false" pointCapturing="3" rightAngleStyle="1" checkboxSize="13" gridType="0"/>
	<bgColor r="255" g="255" b="255"/>
	<axesColor r="0" g="0" b="0"/>
	<gridColor r="192" g="192" b="192"/>
	<lineStyle axes="1" grid="10"/>
	<axis id="0" show="true" label="" unitLabel="" tickStyle="1" showNumbers="true"/>
	<axis id="1" show="true" label="" unitLabel="" tickStyle="1" showNumbers="true"/>
</euclidianView>
<kernel>
	<continuous val="true"/>
	<decimals val="2"/>
	<angleUnit val="degree"/>
	<algebraStyle val="0"/>
	<coordStyle val="0"/>
	<angleFromInvTrig val="false"/>
</kernel>
<scripting blocked="false" disabled="false"/>
<construction title="prot_limacon" author="" date="">
<element type="point" label="A">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="0.1" speed="1" type="1" playing="false"/>
	<coords x="4.4" y="2.26" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="B">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="3.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Circle">
	<input a0="A" a1="B"/>
	<output a0="c"/>
</command>
<element type="conic" label="c">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eigenvectors  x0="1.0" y0="0.0" z0="1.0" x1="-0.0" y1="1.0" z1="1.0"/>
	<matrix A0="1.0" A1="1.0" A2="19.48" A3="0.0" A4="-4.4" A5="-2.26"/>
	<eqnStyle style="specific"/>
</element>
<command name="Point">
	<input a0="c"/>
	<output a0="C"/>
</command>
<element type="point" label="C">
	<show object="true" label="true"/>
	<objColor r="125" g="125" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="2.5662220302243313" y="3.5346993204538184" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="D">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="8.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="E">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="9.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Line">
	<input a0="C" a1="B"/>
	<output a0="a"/>
</command>
<element type="line" label="a">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<coords x="-0.4653006795461816" y="0.43377796977566874" z="-0.3392098404641306"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eqnStyle style="implicit"/>
</element>
<command name="Circle">
	<input a0="C" a1="Segment[D, E]"/>
	<output a0="d"/>
</command>
<element type="conic" label="d">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eigenvectors  x0="1.0" y0="0.0" z0="1.0" x1="-0.0" y1="1.0" z1="1.0"/>
	<matrix A0="1.0" A1="1.0" A2="18.079594794425375" A3="0.0" A4="-2.5662220302243313" A5="-3.5346993204538184"/>
	<eqnStyle style="specific"/>
</element>
<command name="Intersect">
	<input a0="d" a1="a" a2="2"/>
	<output a0="F"/>
</command>
<element type="point" label="F">
	<show object="true" label="true"/>
	<objColor r="64" g="64" b="64" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<coords x="1.884326201556319" y="2.8032500201977006" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Locus">
	<input a0="F" a1="C"/>
	<output a0="loc1"/>
</command>
<element type="locus" label="loc1">
	<show object="true" label="false"/>
	<objColor r="255" g="51" b="51" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="5" type="10" typeHidden="1"/>
</element>
</construction>
</geogebra> '''
︡ef385dd8-123f-47e2-9db8-06503ef86e50︡︡
︠24cf01d8-00ac-435d-aed8-c042224cabb3i︠
%hide
#auto
html('<script type="text/javascript">document.applets[0].reset();</script>')
︡f0122402-20da-4472-90b5-08f281763b05︡{"html": "<font color='black'><script type=\"text/javascript\">document.applets[0].reset();</script></font>"}︡
︠030cb1fb-314e-4316-8837-e6a2ff962b1ci︠
%hide
automatic_names(True)
load(DATA+'AutDedLocusDeg.sage')
︡f8fa99ad-7bf0-4756-935b-a716091a1b44︡︡
︠94e4dd3a-b5c6-41e8-bcff-076e0c3e4204i︠
%hide
myxml = ''
myxml =  '''<?xml version="1.0" encoding="utf-8"?>
<geogebra format="4.0" id="8e6a4458-d48b-404b-8720-6b90f787493c"  xsi:noNamespaceSchemaLocation="http://www.geogebra.org/ggb.xsd" xmlns="" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >
<gui>
	<window width="800" height="600" />
	<perspectives>
<perspective id="tmp">
	<panes>
		<pane location="" divider="0.4073319755600815" orientation="1" />
	</panes>
	<views>
		<view id="4" toolbar="0 || 2020 , 2021 , 2022 , 66 || 2001 , 2003 , 2002 , 2004 , 2005 || 2040 , 2041 , 2042 , 2044 , 2043" visible="false" inframe="false" stylebar="false" location="1,1" size="200" window="0,0,400,400" />
		<view id="1" visible="true" inframe="false" stylebar="false" location="1" size="575" window="0,0,400,400" />
		<view id="2" visible="true" inframe="false" stylebar="false" location="3" size="400" window="0,0,200,400" />
		<view id="16" visible="false" inframe="true" stylebar="false" location="1" size="150" window="50,50,500,500" />
		<view id="32" visible="false" inframe="true" stylebar="true" location="1" size="150" window="50,50,500,500" />
		<view id="64" visible="false" inframe="true" stylebar="false" location="1" size="150" window="50,50,500,500" />
	</views>
	<toolbar show="true" items="0 39 59 || 1 501 67 , 5 19 , 72 | 2 15 45 , 18 65 , 7 37 | 4 3 8 9 , 13 44 , 58 , 47 || 16 51 64 , 70 | 10 34 53 11 , 24  20 22 , 21 23 | 55 56 57 , 12 || 36 46 , 38 49 50 , 71 | 30 29 54 32 31 33 | 17 26 62 , 14 66 68 | 25 52 60 61 || 40 41 42 , 27 28 35 , 6" />
	<input show="true" cmd="true" top="false" />
</perspective>
	</perspectives>
	<labelingStyle  val="3"/>
	<font  size="12"/>
	<graphicsSettings javaLatexFonts="false"/>
	<consProtColumns  col0="true" col1="true" col2="false" col3="true" col4="false" col5="true" col6="true" col7="false"/>
	<consProtocol useColors="true" addIcons="false" showOnlyBreakpoints="false"/>
</gui>
<euclidianView>
	<size  width="575" height="442"/>
	<coordSystem xZero="133.99999999999991" yZero="296.0" scale="49.99999999999998" yscale="50.0"/>
	<evSettings axes="true" grid="true" gridIsBold="false" pointCapturing="3" rightAngleStyle="1" checkboxSize="13" gridType="0"/>
	<bgColor r="255" g="255" b="255"/>
	<axesColor r="0" g="0" b="0"/>
	<gridColor r="192" g="192" b="192"/>
	<lineStyle axes="1" grid="10"/>
	<axis id="0" show="true" label="" unitLabel="" tickStyle="1" showNumbers="true"/>
	<axis id="1" show="true" label="" unitLabel="" tickStyle="1" showNumbers="true"/>
</euclidianView>
<kernel>
	<continuous val="true"/>
	<decimals val="2"/>
	<angleUnit val="degree"/>
	<algebraStyle val="0"/>
	<coordStyle val="0"/>
	<angleFromInvTrig val="false"/>
</kernel>
<scripting blocked="false" disabled="false"/>
<construction title="prot_limacon" author="" date="">
<element type="point" label="A">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="0.1" speed="1" type="1" playing="false"/>
	<coords x="4.4" y="2.26" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="B">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="3.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Circle">
	<input a0="A" a1="B"/>
	<output a0="c"/>
</command>
<element type="conic" label="c">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eigenvectors  x0="1.0" y0="0.0" z0="1.0" x1="-0.0" y1="1.0" z1="1.0"/>
	<matrix A0="1.0" A1="1.0" A2="19.48" A3="0.0" A4="-4.4" A5="-2.26"/>
	<eqnStyle style="specific"/>
</element>
<command name="Point">
	<input a0="c"/>
	<output a0="C"/>
</command>
<element type="point" label="C">
	<show object="true" label="true"/>
	<objColor r="125" g="125" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="2.5662220302243313" y="3.5346993204538184" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="D">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="8.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="E">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="9.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Line">
	<input a0="C" a1="B"/>
	<output a0="a"/>
</command>
<element type="line" label="a">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<coords x="-0.4653006795461816" y="0.43377796977566874" z="-0.3392098404641306"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eqnStyle style="implicit"/>
</element>
<command name="Circle">
	<input a0="C" a1="Segment[D, E]"/>
	<output a0="d"/>
</command>
<element type="conic" label="d">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eigenvectors  x0="1.0" y0="0.0" z0="1.0" x1="-0.0" y1="1.0" z1="1.0"/>
	<matrix A0="1.0" A1="1.0" A2="18.079594794425375" A3="0.0" A4="-2.5662220302243313" A5="-3.5346993204538184"/>
	<eqnStyle style="specific"/>
</element>
<command name="Intersect">
	<input a0="d" a1="a" a2="2"/>
	<output a0="F"/>
</command>
<element type="point" label="F">
	<show object="true" label="true"/>
	<objColor r="64" g="64" b="64" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<coords x="1.884326201556319" y="2.8032500201977006" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Locus">
	<input a0="F" a1="C"/>
	<output a0="loc1"/>
</command>
<element type="locus" label="loc1">
	<show object="true" label="false"/>
	<objColor r="255" g="51" b="51" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="5" type="10" typeHidden="1"/>
</element>
</construction>
</geogebra> '''
︡8d89c96e-3c01-4bb1-8d64-e1715eee55fe︡︡
︠8c54226a-19c4-478c-8f1e-1aa1ea7a3184i︠
%hide
myxml = ''
myxml =  '''<?xml version="1.0" encoding="utf-8"?>
<geogebra format="4.0" id="8e6a4458-d48b-404b-8720-6b90f787493c"  xsi:noNamespaceSchemaLocation="http://www.geogebra.org/ggb.xsd" xmlns="" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >
<gui>
	<window width="800" height="600" />
	<perspectives>
<perspective id="tmp">
	<panes>
		<pane location="" divider="0.4073319755600815" orientation="1" />
	</panes>
	<views>
		<view id="4" toolbar="0 || 2020 , 2021 , 2022 , 66 || 2001 , 2003 , 2002 , 2004 , 2005 || 2040 , 2041 , 2042 , 2044 , 2043" visible="false" inframe="false" stylebar="false" location="1,1" size="200" window="0,0,400,400" />
		<view id="1" visible="true" inframe="false" stylebar="false" location="1" size="575" window="0,0,400,400" />
		<view id="2" visible="true" inframe="false" stylebar="false" location="3" size="400" window="0,0,200,400" />
		<view id="16" visible="false" inframe="true" stylebar="false" location="1" size="150" window="50,50,500,500" />
		<view id="32" visible="false" inframe="true" stylebar="true" location="1" size="150" window="50,50,500,500" />
		<view id="64" visible="false" inframe="true" stylebar="false" location="1" size="150" window="50,50,500,500" />
	</views>
	<toolbar show="true" items="0 39 59 || 1 501 67 , 5 19 , 72 | 2 15 45 , 18 65 , 7 37 | 4 3 8 9 , 13 44 , 58 , 47 || 16 51 64 , 70 | 10 34 53 11 , 24  20 22 , 21 23 | 55 56 57 , 12 || 36 46 , 38 49 50 , 71 | 30 29 54 32 31 33 | 17 26 62 , 14 66 68 | 25 52 60 61 || 40 41 42 , 27 28 35 , 6" />
	<input show="true" cmd="true" top="false" />
</perspective>
	</perspectives>
	<labelingStyle  val="3"/>
	<font  size="12"/>
	<graphicsSettings javaLatexFonts="false"/>
	<consProtColumns  col0="true" col1="true" col2="false" col3="true" col4="false" col5="true" col6="true" col7="false"/>
	<consProtocol useColors="true" addIcons="false" showOnlyBreakpoints="false"/>
</gui>
<euclidianView>
	<size  width="575" height="442"/>
	<coordSystem xZero="133.99999999999991" yZero="296.0" scale="49.99999999999998" yscale="50.0"/>
	<evSettings axes="true" grid="true" gridIsBold="false" pointCapturing="3" rightAngleStyle="1" checkboxSize="13" gridType="0"/>
	<bgColor r="255" g="255" b="255"/>
	<axesColor r="0" g="0" b="0"/>
	<gridColor r="192" g="192" b="192"/>
	<lineStyle axes="1" grid="10"/>
	<axis id="0" show="true" label="" unitLabel="" tickStyle="1" showNumbers="true"/>
	<axis id="1" show="true" label="" unitLabel="" tickStyle="1" showNumbers="true"/>
</euclidianView>
<kernel>
	<continuous val="true"/>
	<decimals val="2"/>
	<angleUnit val="degree"/>
	<algebraStyle val="0"/>
	<coordStyle val="0"/>
	<angleFromInvTrig val="false"/>
</kernel>
<scripting blocked="false" disabled="false"/>
<construction title="prot_limacon" author="" date="">
<element type="point" label="A">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="0.1" speed="1" type="1" playing="false"/>
	<coords x="4.4" y="2.26" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="B">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="3.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Circle">
	<input a0="A" a1="B"/>
	<output a0="c"/>
</command>
<element type="conic" label="c">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eigenvectors  x0="1.0" y0="0.0" z0="1.0" x1="-0.0" y1="1.0" z1="1.0"/>
	<matrix A0="1.0" A1="1.0" A2="19.48" A3="0.0" A4="-4.4" A5="-2.26"/>
	<eqnStyle style="specific"/>
</element>
<command name="Point">
	<input a0="c"/>
	<output a0="C"/>
</command>
<element type="point" label="C">
	<show object="true" label="true"/>
	<objColor r="125" g="125" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="2.5662220302243313" y="3.5346993204538184" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="D">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="8.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="E">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="9.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Line">
	<input a0="C" a1="B"/>
	<output a0="a"/>
</command>
<element type="line" label="a">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<coords x="-0.4653006795461816" y="0.43377796977566874" z="-0.3392098404641306"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eqnStyle style="implicit"/>
</element>
<command name="Circle">
	<input a0="C" a1="Segment[D, E]"/>
	<output a0="d"/>
</command>
<element type="conic" label="d">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eigenvectors  x0="1.0" y0="0.0" z0="1.0" x1="-0.0" y1="1.0" z1="1.0"/>
	<matrix A0="1.0" A1="1.0" A2="18.079594794425375" A3="0.0" A4="-2.5662220302243313" A5="-3.5346993204538184"/>
	<eqnStyle style="specific"/>
</element>
<command name="Intersect">
	<input a0="d" a1="a" a2="2"/>
	<output a0="F"/>
</command>
<element type="point" label="F">
	<show object="true" label="true"/>
	<objColor r="64" g="64" b="64" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<coords x="1.884326201556319" y="2.8032500201977006" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Locus">
	<input a0="F" a1="C"/>
	<output a0="loc1"/>
</command>
<element type="locus" label="loc1">
	<show object="true" label="false"/>
	<objColor r="255" g="51" b="51" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="5" type="10" typeHidden="1"/>
</element>
</construction>
</geogebra> '''
︡f52148fe-e2c6-4c9f-983f-1ca625dc8b6b︡︡
︠cae11127-d5b0-4585-bab1-c1a6b793d729i︠
%hide
myxml = ''
myxml =  '''<?xml version="1.0" encoding="utf-8"?>
<geogebra format="4.0" id="8e6a4458-d48b-404b-8720-6b90f787493c"  xsi:noNamespaceSchemaLocation="http://www.geogebra.org/ggb.xsd" xmlns="" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" >
<gui>
	<window width="800" height="600" />
	<perspectives>
<perspective id="tmp">
	<panes>
		<pane location="" divider="0.4073319755600815" orientation="1" />
	</panes>
	<views>
		<view id="4" toolbar="0 || 2020 , 2021 , 2022 , 66 || 2001 , 2003 , 2002 , 2004 , 2005 || 2040 , 2041 , 2042 , 2044 , 2043" visible="false" inframe="false" stylebar="false" location="1,1" size="200" window="0,0,400,400" />
		<view id="1" visible="true" inframe="false" stylebar="false" location="1" size="575" window="0,0,400,400" />
		<view id="2" visible="true" inframe="false" stylebar="false" location="3" size="400" window="0,0,200,400" />
		<view id="16" visible="false" inframe="true" stylebar="false" location="1" size="150" window="50,50,500,500" />
		<view id="32" visible="false" inframe="true" stylebar="true" location="1" size="150" window="50,50,500,500" />
		<view id="64" visible="false" inframe="true" stylebar="false" location="1" size="150" window="50,50,500,500" />
	</views>
	<toolbar show="true" items="0 39 59 || 1 501 67 , 5 19 , 72 | 2 15 45 , 18 65 , 7 37 | 4 3 8 9 , 13 44 , 58 , 47 || 16 51 64 , 70 | 10 34 53 11 , 24  20 22 , 21 23 | 55 56 57 , 12 || 36 46 , 38 49 50 , 71 | 30 29 54 32 31 33 | 17 26 62 , 14 66 68 | 25 52 60 61 || 40 41 42 , 27 28 35 , 6" />
	<input show="true" cmd="true" top="false" />
</perspective>
	</perspectives>
	<labelingStyle  val="3"/>
	<font  size="12"/>
	<graphicsSettings javaLatexFonts="false"/>
	<consProtColumns  col0="true" col1="true" col2="false" col3="true" col4="false" col5="true" col6="true" col7="false"/>
	<consProtocol useColors="true" addIcons="false" showOnlyBreakpoints="false"/>
</gui>
<euclidianView>
	<size  width="575" height="442"/>
	<coordSystem xZero="133.99999999999991" yZero="296.0" scale="49.99999999999998" yscale="50.0"/>
	<evSettings axes="true" grid="true" gridIsBold="false" pointCapturing="3" rightAngleStyle="1" checkboxSize="13" gridType="0"/>
	<bgColor r="255" g="255" b="255"/>
	<axesColor r="0" g="0" b="0"/>
	<gridColor r="192" g="192" b="192"/>
	<lineStyle axes="1" grid="10"/>
	<axis id="0" show="true" label="" unitLabel="" tickStyle="1" showNumbers="true"/>
	<axis id="1" show="true" label="" unitLabel="" tickStyle="1" showNumbers="true"/>
</euclidianView>
<kernel>
	<continuous val="true"/>
	<decimals val="2"/>
	<angleUnit val="degree"/>
	<algebraStyle val="0"/>
	<coordStyle val="0"/>
	<angleFromInvTrig val="false"/>
</kernel>
<scripting blocked="false" disabled="false"/>
<construction title="prot_limacon" author="" date="">
<element type="point" label="A">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="0.1" speed="1" type="1" playing="false"/>
	<coords x="4.4" y="2.26" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="B">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="3.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Circle">
	<input a0="A" a1="B"/>
	<output a0="c"/>
</command>
<element type="conic" label="c">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eigenvectors  x0="1.0" y0="0.0" z0="1.0" x1="-0.0" y1="1.0" z1="1.0"/>
	<matrix A0="1.0" A1="1.0" A2="19.48" A3="0.0" A4="-4.4" A5="-2.26"/>
	<eqnStyle style="specific"/>
</element>
<command name="Point">
	<input a0="c"/>
	<output a0="C"/>
</command>
<element type="point" label="C">
	<show object="true" label="true"/>
	<objColor r="125" g="125" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="2.5662220302243313" y="3.5346993204538184" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="D">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="8.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<element type="point" label="E">
	<show object="true" label="true"/>
	<objColor r="0" g="0" b="255" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<animation step="1" speed="1" type="1" playing="false"/>
	<coords x="9.0" y="4.0" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Line">
	<input a0="C" a1="B"/>
	<output a0="a"/>
</command>
<element type="line" label="a">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<coords x="-0.4653006795461816" y="0.43377796977566874" z="-0.3392098404641306"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eqnStyle style="implicit"/>
</element>
<command name="Circle">
	<input a0="C" a1="Segment[D, E]"/>
	<output a0="d"/>
</command>
<element type="conic" label="d">
	<show object="true" label="false"/>
	<objColor r="0" g="0" b="0" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="2" type="0" typeHidden="1"/>
	<eigenvectors  x0="1.0" y0="0.0" z0="1.0" x1="-0.0" y1="1.0" z1="1.0"/>
	<matrix A0="1.0" A1="1.0" A2="18.079594794425375" A3="0.0" A4="-2.5662220302243313" A5="-3.5346993204538184"/>
	<eqnStyle style="specific"/>
</element>
<command name="Intersect">
	<input a0="d" a1="a" a2="2"/>
	<output a0="F"/>
</command>
<element type="point" label="F">
	<show object="true" label="true"/>
	<objColor r="64" g="64" b="64" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<coords x="1.884326201556319" y="2.8032500201977006" z="1.0"/>
	<pointSize val="3"/>
	<pointStyle val="0"/>
</element>
<command name="Locus">
	<input a0="F" a1="C"/>
	<output a0="loc1"/>
</command>
<element type="locus" label="loc1">
	<show object="true" label="false"/>
	<objColor r="255" g="51" b="51" alpha="0.0"/>
	<layer val="0"/>
	<labelMode val="0"/>
	<lineStyle thickness="5" type="10" typeHidden="1"/>
</element>
</construction>
</geogebra> '''
︡a85be722-0509-4783-ad37-21b3a7b12f95︡︡
